gtkmm: Gtk::PadController Class Reference

gtkmm 4.8.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::PadController Class Reference
Event Controllers and Gestures

Event controller for drawing tablet pads. More...

`#include <gtkmm/padcontroller.h>`

Inheritance diagram for Gtk::PadController:
[legend]

## Public Member Functions
| PadController (PadController && src) noexcept
PadController & | operator= (PadController && src) noexcept
| ~PadController () noexcept override
GtkPadController * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkPadController * | gobj () const
| Provides access to the underlying C GObject. More...
GtkPadController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_action_entries (const std::vector< PadActionEntry > & entries)
| This is a convenience function to add a group of action entries on the pad controller. More...
void | set_action (PadActionType type, int index, int mode, const Glib::ustring & label, const Glib::ustring & action_name)
| Adds an individual action to controller. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::ActionGroup > > | property_action_group () const
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Device > > | property_pad () const
Public Member Functions inherited from Gtk::EventController
| EventController (EventController && src) noexcept
EventController & | operator= (EventController && src) noexcept
| ~EventController () noexcept override
GtkEventController * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkEventController * | gobj () const
| Provides access to the underlying C GObject. More...
GtkEventController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Widget * | get_widget ()
| Returns the `Gtk::Widget` this controller relates to. More...
const Widget * | get_widget () const
| Returns the `Gtk::Widget` this controller relates to. More...
void | reset ()
| Resets the controller to a clean state. More...
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events. More...
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events. More...
PropagationLimit | get_propagation_limit () const
| Gets the propagation limit of the event controller. More...
void | set_propagation_limit (PropagationLimit limit)
| Sets the event propagation limit on the event controller. More...
Glib::ustring | get_name () const
| Gets the name of controller. More...
void | set_name (const Glib::ustring & name)
| Sets a name on the controller that can be used for debugging. More...
Glib::RefPtr< const Gdk::Event > | get_current_event () const
| Returns the event that is currently being handled by the controller. More...
guint32 | get_current_event_time () const
| Returns the timestamp of the event that is currently being handled by the controller. More...
Glib::RefPtr< Gdk::Device > | get_current_event_device ()
| Returns the device of the event that is currently being handled by the controller. More...
Glib::RefPtr< const Gdk::Device > | get_current_event_device () const
| Returns the event that is currently being handled by the controller. More...
Gdk::ModifierType | get_current_event_state () const
| Returns the modifier state of the event that is currently being handled by the controller. More...
Glib::PropertyProxy_ReadOnly< Widget * > | property_widget () const
| The widget receiving the `Gdk::Events` that the controller will handle. More...
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy< PropagationLimit > | property_propagation_limit ()
| The limit for which events this controller will handle. More...
Glib::PropertyProxy_ReadOnly< PropagationLimit > | property_propagation_limit () const
| The limit for which events this controller will handle. More...
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name for this controller, typically used for debugging purposes. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name for this controller, typically used for debugging purposes. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< PadController > | create (const Glib::RefPtr< Gio::ActionGroup > & action_group, const Glib::RefPtr< Gdk::Device > & pad={})
| Creates a new Gtk::PadController that will associate events from pad to actions. More...
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| PadController (const Glib::RefPtr< Gio::ActionGroup > & action_group, const Glib::RefPtr< Gdk::Device > & pad={})
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::PadController > | wrap (GtkPadController * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)

## Detailed Description

Event controller for drawing tablet pads.

Gtk::PadController is an event controller for the pads found in drawing tablets (The collection of buttons and tactile sensors often found around the stylus-sensitive area).

These buttons and sensors have no implicit meaning, and by default they perform no action. This event controller is provided to map those to Gio::Action objects, thus letting the application give those a more semantic meaning.

Buttons and sensors are not constrained to triggering a single action, some Gdk::InputSource::TABLET_PAD devices feature multiple "modes". All these input elements have one current mode, which may determine the final action being triggered. Pad devices often divide buttons and sensors into groups. All elements in a group share the same current mode, but different groups may have different modes. See Gdk::DevicePad::get_n_groups() and Gdk::DevicePad::get_group_n_modes().

Each of the actions that a given button/strip/ring performs for a given mode is defined by a Gtk::PadActionEntry. It contains an action name that will be looked up in the given Gio::ActionGroup and activated whenever the specified input element and mode are triggered.

A simple example of Gtk::PadController usage, assigning button 1 in all modes and pad devices to a "black" action and button 2 to a "pink" action:

auto action_group = Gio::SimpleActionGroup::create();
auto pad_controller = Gtk::PadController::create(action_group);
std::vector<Gtk::PadActionEntry> entries = {
{ Gtk::PadActionType::BUTTON, 1, -1, "Black", "pad.black" },
{ Gtk::PadActionType::BUTTON, 2, -1, "Pink", "pad.pink" },
};
for (const auto& entry : entries)
action_group->add_action(entry.get_action_name(), sigc::mem_fun(*this, &MyWindow::on_pad_activated));
pad_controller->set_action_entries(entries);
// Assuming the code is in the MyWindow constructor.
add_controller(pad_controller);
std::vector
Gio::SimpleActionGroup::create
static Glib::RefPtr< SimpleActionGroup > create()
Gtk::PadController::create
static Glib::RefPtr< PadController > create(const Glib::RefPtr< Gio::ActionGroup > &action_group, const Glib::RefPtr< Gdk::Device > &pad={})
Creates a new Gtk::PadController that will associate events from pad to actions.
Gtk::PadActionType::BUTTON
@ BUTTON
Action is triggered by a pad button.

The actions belonging to rings/strips will be activated with a parameter of type Glib::Variant<double> bearing the value of the given axis. It is required that those are made stateful and accepting this Glib::VariantType.

See also
  Gtk::EventController, Gdk::DevicePad

Since gtkmm 3.96:

## Constructor & Destructor Documentation

## ◆ PadController() [1/2]

Gtk::PadController::PadController | ( | PadController && | src | ) |
| noexcept

## ◆ ~PadController()

Gtk::PadController::~PadController | ( |  | ) |
| overridenoexcept

## ◆ PadController() [2/2]

Gtk::PadController::PadController | ( | const Glib::RefPtr< Gio::ActionGroup > & | action_group,
|  | const Glib::RefPtr< Gdk::Device > & | pad = `{}`
| ) |  |
| explicitprotected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< PadController > Gtk::PadController::create | ( | const Glib::RefPtr< Gio::ActionGroup > & | action_group,
|  | const Glib::RefPtr< Gdk::Device > & | pad = `{}`
| ) |  |
| static

Creates a new Gtk::PadController that will associate events from pad to actions.

An empty Glib::RefPtr pad may be provided so the controller manages all pad devices generically. It is discouraged to mix Gtk::PadController objects with empty and non-empty pad argument on the same toplevel window, as execution order is not guaranteed.

The Gtk::PadController is created with no mapped actions. In order to map pad events to actions, use set_action_entries() or set_action().

Be aware that pad events will only be delivered to Gtk::Windows, so adding a pad controller to any other type of widget will not have an effect.

Parameters

  group | Gio::ActionGroup to trigger actions from.
  pad | A Gdk::InputSource::TABLET_PAD device, or an empty Glib::RefPtr to handle all pads.

Returns
  A newly created Gtk::PadController.

## ◆ get_type()

static GType Gtk::PadController::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkPadController * Gtk::PadController::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkPadController * Gtk::PadController::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkPadController * Gtk::PadController::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

PadController & Gtk::PadController::operator= | ( | PadController && | src | ) |
| noexcept

## ◆ property_action_group()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::ActionGroup > > Gtk::PadController::property_action_group | ( |  | ) | const

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pad()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Device > > Gtk::PadController::property_pad | ( |  | ) | const

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_action()

void Gtk::PadController::set_action | ( | PadActionType | type,
|  | int | index,
|  | int | mode,
|  | const Glib::ustring & | label,
|  | const Glib::ustring & | action_name
| ) |  |

Adds an individual action to controller.

This action will only be activated if the given button/ring/strip number in index is interacted while the current mode is mode. -1 may be used for simple cases, so the action is triggered on all modes.

The given label should be considered user-visible, so internationalization rules apply. Some windowing systems may be able to use those for user feedback.

Parameters

  type | The type of pad feature that will trigger this action.
  index | The 0-indexed button/ring/strip number that will trigger this action.
  mode | The mode that will trigger this action, or -1 for all modes.
  label | Human readable description of this action, this string should be deemed user-visible.
  action_name | Action name that will be activated in the `Gio::ActionGroup`.

## ◆ set_action_entries()

void Gtk::PadController::set_action_entries | ( | const std::vector< PadActionEntry > & | entries | ) |

This is a convenience function to add a group of action entries on the pad controller.

See Gtk::PadActionEntry and set_action().

Parameters

  entries | The action entries to set on the controller.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::PadController > wrap | ( | GtkPadController * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.